# coding: utf-8

"""
    CDO API

    Use the documentation to explore the endpoints CDO has to offer

    The version of the OpenAPI document: 1.5.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class JsonWebKey(BaseModel):
    """
    The JSON Web Key Set.
    """ # noqa: E501
    kty: Optional[StrictStr] = Field(default=None, description="The family of cryptographic algorithms used with the key.")
    e: Optional[StrictStr] = Field(default=None, description="The exponent for the RSA public key.")
    use: Optional[StrictStr] = Field(default=None, description="How the key was meant to be used.")
    kid: Optional[StrictStr] = Field(default=None, description="The unique identifier for the key.")
    alg: Optional[StrictStr] = Field(default=None, description="The specific cryptographic algorithm used with the key.")
    n: Optional[StrictStr] = Field(default=None, description="The modulus for the RSA public key.")
    __properties: ClassVar[List[str]] = ["kty", "e", "use", "kid", "alg", "n"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JsonWebKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JsonWebKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "kty": obj.get("kty"),
            "e": obj.get("e"),
            "use": obj.get("use"),
            "kid": obj.get("kid"),
            "alg": obj.get("alg"),
            "n": obj.get("n")
        })
        return _obj


