# coding: utf-8

"""
    CDO API

    Use the documentation to explore the endpoints CDO has to offer

    The version of the OpenAPI document: 1.5.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RedirectViewServletContextFilterRegistrationsValue(BaseModel):
    """
    RedirectViewServletContextFilterRegistrationsValue
    """ # noqa: E501
    servlet_name_mappings: Optional[List[StrictStr]] = Field(default=None, alias="servletNameMappings")
    url_pattern_mappings: Optional[List[StrictStr]] = Field(default=None, alias="urlPatternMappings")
    name: Optional[StrictStr] = None
    class_name: Optional[StrictStr] = Field(default=None, alias="className")
    init_parameters: Optional[Dict[str, StrictStr]] = Field(default=None, alias="initParameters")
    __properties: ClassVar[List[str]] = ["servletNameMappings", "urlPatternMappings", "name", "className", "initParameters"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RedirectViewServletContextFilterRegistrationsValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RedirectViewServletContextFilterRegistrationsValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "servletNameMappings": obj.get("servletNameMappings"),
            "urlPatternMappings": obj.get("urlPatternMappings"),
            "name": obj.get("name"),
            "className": obj.get("className"),
            "initParameters": obj.get("initParameters")
        })
        return _obj


